use warnings;
use strict;
use PPI::Document;

my $source = <<'EOS';
ModuleA::func1;
Module::A::func2;
ModuleA::func3();
Module::A::func4();
ModuleB->method;
EOS

my $doc   = PPI::Document->new( \$source );
my $words = $doc->find('PPI::Token::Word');

for my $word (@$words) {

    # $word は PPI::Token::Word である
    my ( $module, $func ) = $word =~ /((?:[A-Z]\w*::)+)(\w+)/;

    if ( $module && $func ) {

        # 末尾に :: が付いているので削除
        $module = substr( $module, 0, -2 );
        print "module: $module, func: $func\n";
    }
}
