use warnings;
use strict;
use PPI::Document;

my $source = <<'EOS';
ModuleA::func;
ModuleB->method1;
Module::B->method2;
ModuleB->method3();
Module::B->method4();
EOS

my $doc   = PPI::Document->new( \$source );
my $words = $doc->find('PPI::Token::Word');

for my $word (@$words) {

    my $prev = $word->sprevious_sibling;
    if ( $word->method_call && $prev eq '->' ) {
        my $module = $prev->sprevious_sibling;
        my $func   = $word;
        if ( $module && $func ) {
            print "module: $module, func: $func\n";
        }
    }
}
