use warnings;
use strict;
use Array::Diff;
use PPI::Document;
use PPI::Token::Whitespace;

my $source = <<'EOS';
use ModuleA;

ModuleA::func1;
Module::A::func2;
ModuleA::func3();
Module::A::func4();
ModuleB->method1;
Module::B->method2;
ModuleB->method3();
Module::B->method4();
EOS

my $doc = PPI::Document->new( \$source );

my $need_modules = [
    qw(
      Module::A
      ModuleB
      Module::B
    )
];

# PPI::Statement::Include に変換する
my $create_inc = sub {
    my $str = shift;
    my $d   = PPI::Document->new( \"$str" );
    $d->find_first('PPI::Statement::Include')->clone;
};

for my $module (@$need_modules) {
    my $inc = $create_inc->("use $module;");
    $inc->add_element( PPI::Token::Whitespace->new("\n") );
    $doc->first_element->insert_before($inc);
}

# もとのファイルの内容に use文が追加された状態
my $formatted = $doc->serialize;
print $formatted;
