use warnings;
use strict;
use PPI::Document;
use Data::Dumper;

my $source = <<'EOS';
my $dog = create_dog();
my $cat = create_cat(eye_color => 'blue');
sleep 1;
if(somefunc) {
   print "called somefunc"; 
}
EOS

my $doc = PPI::Document->new(\$source);

my $candidates = $doc->find(
  sub {
    my $el = $_[1]; # 条件をテストする Element
    my $p = $el->parent; # 親の Element
    (
     # (例) sleep 1; にマッチ
     $p->class eq 'PPI::Statement' ||
     
     # (例) my $var = somefunc; にマッチ
     $p->isa('PPI::Statement::Variable') ||
     
     # (例) if(somefunc) にマッチ
     $p->isa('PPI::Statement::Expression')
    ) && $el->isa('PPI::Token::Word');
  }
);

# myキーワード や ハッシュのキー にもマッチするので別途取り除く必要がある
print "candidates\n";
print Dumper $candidates;